Bug 1351071 - [geo-rep] Stopped geo-rep session gets started automatically once all the master nodes are upgraded
Summary: [geo-rep] Stopped geo-rep session gets started automatically once all the mas...
Status: CLOSED CURRENTRELEASE
Alias: None
Product: GlusterFS
Classification: Community
Component: geo-replication
Version: mainline
Hardware: x86_64
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Saravanakumar
QA Contact:
URL:
Whiteboard:
Keywords: ZStream
Depends On: 1347625
Blocks: 1368053 1368055
TreeView+ depends on / blocked
 
Reported: 2016-06-29 07:25 UTC by Saravanakumar
Modified: 2017-03-10 06:33 UTC (History)
5 users (show)

(edit)
Clone Of: 1347625
: 1368053 1368055 (view as bug list)
(edit)
Last Closed: 2017-03-10 06:33:12 UTC


Attachments (Terms of Use)

Comment 1 Saravanakumar 2016-06-29 07:31:37 UTC
Once glusterfs is upgraded (which involves geo-replication slave volume uuid as part of vol info), if geo-replication status command is run, it creates an empty monitor.status file (without restarting glusterd daemon)

Now, once the glusterd is restarted after the above step, glusterd updates the monitor.status file with "Started" state.

This "Started" state gets reflected if you run "gluster volume geo-replication MasterVolume Slavehost::Slavevolume status" command.

Solution is to avoid updating monitor.status file(with "Started" status) if monitor.status is empty.

Comment 2 Vijay Bellur 2016-06-29 10:16:54 UTC
REVIEW: http://review.gluster.org/14830 (glusterd/geo-rep: Handle empty monitor.status during upgrade) posted (#1) for review on master by Saravanakumar Arumugam (sarumuga@redhat.com)

Comment 3 Vijay Bellur 2016-07-11 10:11:45 UTC
REVIEW: http://review.gluster.org/14830 (glusterd/geo-rep: Handle empty monitor.status during upgrade) posted (#2) for review on master by Saravanakumar Arumugam (sarumuga@redhat.com)

Comment 4 Vijay Bellur 2016-07-11 22:50:18 UTC
COMMIT: http://review.gluster.org/14830 committed in master by Jeff Darcy (jdarcy@redhat.com) 
------
commit f938b3a26ffab9482d5f910ee76d2bb2b370517f
Author: Saravanakumar Arumugam <sarumuga@redhat.com>
Date:   Wed Jun 29 15:36:06 2016 +0530

    glusterd/geo-rep: Handle empty monitor.status during upgrade
    
    Problem:
    Consider geo-replication is in Stopped state.
    Following which, glusterfs is upgraded (where monitor.status is the new status file).
    
    Now, When geo-replication status command is run,
    empty monitor status file gets created.
    
    Now, if glusterd is restarted, it reads empty monitor status
    and  starts geo-replication session. This is incorrect as session
    was in Stopped state earlier.
    
    Solution:
    If monitor status is empty, error out and avoid
    starting geo-replication session.
    
    Note: if monitor status is empty, geo-rep session is displayed
    as Stopped state.
    
    Change-Id: Ifb3db896e5ed92b927764cf1163503765cb08bb4
    BUG: 1351071
    Signed-off-by: Saravanakumar Arumugam <sarumuga@redhat.com>
    Reviewed-on: http://review.gluster.org/14830
    Smoke: Gluster Build System <jenkins@build.gluster.org>
    CentOS-regression: Gluster Build System <jenkins@build.gluster.org>
    NetBSD-regression: NetBSD Build System <jenkins@build.gluster.org>
    Reviewed-by: Jeff Darcy <jdarcy@redhat.com>


Note You need to log in before you can comment on or make changes to this bug.